// comm.h
//
#include "general.h"

class Port {
	int buffer_used_size;		// Read buffer size.
	int buffer_parsed_size;		// Parsed buffer size.

	int my_sequence;			// My last sequence.
	int other_sequence;			// His last sequence.
	unsigned char ch[4];		// Data buffer to send.
	unsigned char lastch[4];	// Packet Last sent : MAB
	int state;
	int waiting;				// Waiting OK.
	int board_size;
	int index;
	int nextquery;
	int	query_code;
  // Game status.
	int blackCount;
	int whiteCount;
	int currentTurnCount;
	int my_color;
	int is_running;
	int my_used_time;
	int others_used_time;
	int handicap;			// D4 Q16 D16 Q4 (K10 when handicap is odd)
							// D10 Q10 K4 K16

	int current_color;
	int rx, ry;					// recieve x,y
	BOOL recieved;

	// Command and args of the current protocol.
	int command;
	int arg;

	void exec (void);			// Execute the read data.
	void doCommand (int command, int arg);
	unsigned char get_checksum (unsigned char *c);	// Calc checksum and update data.
	int get_command(void);		// Get the command No.
	int get_arg (void);			// Get the argument.
	void SetCommand (int com, int arg);	// Create data from command and args.
	void ParseMove (int val);
	void setBoardSize (int s) { board_size = s; }
	int getBoardSize (void) { return board_size; }
	void SetHandicap (int handi);
	void state_init (void);		// Initialize the game status.

public:
	Port (void);
	void PutQuery(void);
	void Parse (unsigned char c);		// Parse the read data.

  // Commands of the protocol.
	void NewGame (int s);
	void ExecMove (void);

	void Send (int send_command, int send_arg);
	void SendAgain (void);
	void SendMove (int x, int y);
	int RecieveMove(int *px, int *py);
	void ClearRecieve(void);
	int CheckOK(void);
};
